<script setup lang="ts">
import { computed, ref, watch } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import GitApiCall from '@/api/gitApi'

// Define the props with TypeScript types
interface Props {
  groupId: number
  fileContentData: Record<string, any>
  branch: string
  idProject: number
  route: string
}

const props = defineProps<Props>()
const router = useRouter()

// Define local state variables with TypeScript types
const gitlabInputVarsData = ref<any[]>([])
const validInputValues = ref<string[]>(['input', 'password', 'email', 'selector', 'file', 'checkbox', 'textarea'])
const envVars = ref<Record<string, any>>({})
const contentDataModel = ref<Record<string, any>>({})
const disabledGroups = ref<string[]>([])
const checkboxValues = ref<Record<string, boolean>>({})
const errorMessage = ref<string>('')
const errorVariant = ref<string>('danger')

// added
const step = ref(1)
const SelectGroups = ref<boolean>(false)

interface Tab {
  enabled: boolean
  name: string
}
const tabsToShow = ref<Tab[]>([])

const schedule = ref({
  description: '',
  intervalPattern: '',
  isActive: true,
})

const showScheduleGroup = ref<boolean>(false)
const showVariablesGroup = ref<boolean>(true)
const saving = ref<boolean>(false)
const isRequest = ref<boolean>(false)
const isError = ref<boolean>(false)
const requestMessage = ref<string>('')

const filteredContentDataModel = computed(() => {
  // Get the list of enabled tab names from tabsToShow
  const enabledTabs = tabsToShow.value.filter(tab => tab.enabled).map(tab => tab.name)

  // Filter contentDataModel based on enabledTabs
  return Object.fromEntries(
    Object.entries(contentDataModel.value).filter(([key, group]) =>
      enabledTabs.includes(group.title),
    ),
  )
})

watch(() => props.fileContentData, () => {
  createDefaultValues()
  contentDataModel.value = JSON.parse(JSON.stringify(props.fileContentData))
  tabsToShow.value = Object.values(contentDataModel.value).map(item => ({
    name: item.title, // Spread the original item properties
    enabled: true, // Add the enabled property
  }))
  console.log('fileContentData -> envVars:', envVars.value)
})

watch(envVars, (newValues, oldValues) => {
  console.log('Cambio detectado en envVars:', newValues)
  for (const key in newValues) {
    if (newValues[key] !== oldValues[key])
      console.log(`Cambio en ${key}:`, newValues[key])
  }
}, { deep: true })

watch(() => props.branch, (newBranch, oldBranch) => {
  console.log('[PipelineSetupFormComponent] Branch changed from', oldBranch, 'to', newBranch)
  step.value = 1
})

const alertToggleVariant = computed(() => isError.value ? 'danger' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error detected' : 'Success!')

const hasLabelField = (options: Array<{ label?: string; value: any }>): boolean => {
  return options.every(option => 'label' in option)
}

interface EnvVarContent {
  hidden: boolean
  value: any // Replace 'any' with the actual type if you know it
}

async function fetchGitlabInputVars() {
  gitlabInputVarsData.value = await Object.entries(envVars.value).reduce(async (accPromise, [groupKey, groupValue]: [string, Record<string, EnvVarContent>]) => {
    const acc = await accPromise
    if (!disabledGroups.value.includes(groupKey)) {
      const groupData = await Object.entries(groupValue).reduce(
        async (groupAccPromise, [contentKey, contentValue]: [string, EnvVarContent]) => {
          const groupAcc = await groupAccPromise
          if (!contentValue.hidden) {
            const { value } = contentValue
            const { type } = props.fileContentData[groupKey].content[contentKey]
            let varContent = null
            if (type === 'file') {
              if (value) {
                varContent = {
                  key: contentKey,
                  variable_type: 'file',
                  value: await value.text(),
                }
              }
            }
            else if (type === 'selector') {
              varContent = {
                key: contentKey,
                value: value.value,
              }
            }
            else {
              varContent = {
                key: contentKey,
                value,
              }
            }
            if (varContent)
              groupAcc.push(varContent)
          }

          return groupAcc
        }, Promise.resolve<any[]>([]),
      )

      acc.push(...groupData)
    }

    return acc
  }, Promise.resolve<any[]>([]))
}

function createDefaultValues() {
  Object.keys(props.fileContentData).forEach(group => {
    envVars.value[group] = {}
    checkboxValues.value[group] = true
    Object.keys(props.fileContentData[group].content).forEach(key => {
      envVars.value[group][key] = {
        value: props.fileContentData[group].content[key].default,
        hidden: false,
      }
    })
  })

  console.log('createDefaultValues this.EnvVars: ', envVars.value)
}

function handleFormsChange() {
  console.log('this.envVars:', envVars.value)

  for (const groupKey in envVars.value) {
    if (!disabledGroups.value.includes(groupKey)) {
      for (const contentKey in envVars.value[groupKey]) {
        const { value, hidden } = envVars.value[groupKey][contentKey]
        const { label, type, id, hide_on: contentHideOn } = props.fileContentData[groupKey].content[contentKey]

        console.log('==================================:')
        console.log(`Analyzing content of group: [${groupKey}] and content: [${contentKey}]`)
        console.log('launchPipelineButton [type]:', type)
        console.log('launchPipelineButton value:', value)
        console.log('launchPipelineButton hidden:', hidden)
        console.log('launchPipelineButton id:', id)
        console.log('launchPipelineButton contentHideOn:', contentHideOn)

        if (contentHideOn && contentHideOn.equals) {
          console.log('launchPipelineButton equals:', contentHideOn.equals)

          for (const equalKey in contentHideOn.equals) {
            console.log('equalKey', equalKey)

            if (!envVars.value[groupKey] || !(equalKey in envVars.value[groupKey])) {
              console.error('Error: Key does not exist:', equalKey)

              errorMessage.value = `<strong>ERROR:</strong> Error in the format of main.json. The selector
                <strong>[${contentKey}]</strong> with label: <strong>${label}</strong> inside the group:
                <strong>[${groupKey}]</strong> depends on the key <strong>${equalKey}</strong>,
                which does not exist in <strong>main.json[${groupKey}]</strong>.`
              errorVariant.value = 'danger'
              break
            }

            let equalValue = envVars.value[groupKey][equalKey].value
            const equalType = props.fileContentData[groupKey].content[equalKey].type
            if (equalType === 'selector')
              equalValue = equalValue.value

            if (equalValue === contentHideOn.equals[equalKey]) {
              console.log('this.envVars[groupKey][equalKey].value', equalValue)
              console.log('contentHideOn.equals[equalKey]', contentHideOn.equals[equalKey])
              envVars.value[groupKey][contentKey].hidden = true
              break
            }
            else {
              envVars.value[groupKey][contentKey].hidden = false
            }
          }
        }
        if (contentHideOn && contentHideOn.not_equals) {
          console.log('launchPipelineButton not_equals:', contentHideOn.not_equals)

          for (const equalKey in contentHideOn.not_equals) {
            console.log('equalKey', equalKey)

            if (!envVars.value[groupKey] || !(equalKey in envVars.value[groupKey])) {
              console.error('Error: Key does not exist:', equalKey)

              errorMessage.value = `<strong>ERROR:</strong> Error in the format of main.json. The selector
                <strong>[${contentKey}]</strong> with label: <strong>${label}</strong> inside the group:
                <strong>[${groupKey}]</strong> depends on the key <strong>${equalKey}</strong>,
                which does not exist in <strong>main.json[${groupKey}]</strong>.`
              errorVariant.value = 'danger'
              break
            }

            let equalValue = envVars.value[groupKey][equalKey].value
            const equalType = props.fileContentData[groupKey].content[equalKey].type
            if (equalType === 'selector')
              equalValue = equalValue.value

            if (equalValue !== contentHideOn.not_equals[equalKey]) {
              console.debug('DEBUG: this.envVars[groupKey][equalKey].value', equalValue)
              console.debug('DEBUG: contentHideOn.not_equals[equalKey]', contentHideOn.not_equals[equalKey])
              envVars.value[groupKey][contentKey].hidden = true
              break
            }
            else {
              envVars.value[groupKey][contentKey].hidden = false
            }
          }
        }
        console.log('----------------------------------:')

        if (type === 'input') {
          console.log('input contentKey:', contentKey)
          console.log('input value:', value)
        }
        else if (type === 'checkbox') {
          console.log('checkbox contentKey:', contentKey)
          console.log('checkbox value:', value)
        }
        else if (type === 'selector') {
          console.log('selector contentKey:', contentKey)
          console.log('selector value:', value.value)
        }
      }
    }
  }

  // Vue 3 does not require this.$forceUpdate()
}

async function onCompleteWizard() {
  if (showScheduleGroup.value)
    await schedulePipelineButton()
  else
    await launchPipelineButton()
}

async function launchPipelineButton() {
  console.info('INFO: launchPipelineButton for project: ', props.idProject)
  saving.value = true

  const git = new GitApiCall()
  try {
    await fetchGitlabInputVars()
    console.debug('DEBUG: launchPipelineButton branch: ', props.branch)

    const response = await git.launchPipeline(props.idProject.toString(), gitlabInputVarsData.value, props.branch)
    const pipeline = response.data

    console.debug('DEBUG: launchPipelineButton pipeline: ', pipeline)

    const route = {
      name: `${props.route}-pipeline-execution`,
      params: { id: props.groupId, projectId: props.idProject, pipelineId: pipeline.id },
    }

    console.debug('DEBUG: launchPipelineButton route: ', route)
    isError.value = false
    await router.push(route)
  }
  catch (error) {
    console.debug('ERROR launchPipelineButton', error)
    if (error instanceof Error && (error as any).response) {
      if ((error as any).response.data.message.base)
        requestMessage.value = (error as any).response.data.message.base
      else
        requestMessage.value = (error as any).response.data.message
    }
    else {
      // Handle the error case where error doesn't have the expected shape
      requestMessage.value = 'An unknown error occurred'
    }
    console.debug('ERROR requestMessage', requestMessage)
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}

async function schedulePipelineButton() {
  console.info('INFO: schedulePipelineButton for project: ', props.idProject)
  saving.value = true

  const gitApi = new GitApiCall()
  try {
    const scheduleResponse = await gitApi.schedulePipeline(
      props.idProject.toString(),
      props.branch,
      schedule.value.intervalPattern,
      schedule.value.description,
      schedule.value.isActive,
    )

    console.debug('DEBUG: schedulePipelineButton schedulePipeline: ', scheduleResponse.data)

    const scheduleId = scheduleResponse.data.id

    await fetchGitlabInputVars()

    const promises = gitlabInputVarsData.value.map(async variable => {
      console.debug('DEBUG: schedulePipelineButton variable: ', variable)

      const variableType = variable.variable_type || null

      const response = await gitApi.addVariableToSchedule(
        props.idProject.toString(),
        scheduleId,
        variable.key,
        variable.value,
        variableType,
      )

      console.debug('DEBUG: schedulePipelineButton response: ', response)
    })

    await Promise.all(promises)
    isError.value = false

    const route_path = useRoute()

    await router.replace({ query: { ...route_path.query, tab: '3' } })
  }
  catch (error) {
    console.debug('ERROR schedulePipelineButton', error)
    if (error instanceof Error && (error as any).response) {
      if ((error as any).response.data.message.base)
        requestMessage.value = (error as any).response.data.message.base
      else
        requestMessage.value = (error as any).response.data.message
    }
    else {
      // Handle the error case where error doesn't have the expected shape
      requestMessage.value = 'An unknown error occurred'
    }
    console.debug('ERROR requestMessage', requestMessage)
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}
</script>

<template>
  <!-- Wizard Component -->
  <VStepper
    v-model="step"
    vertical
    :items="Object.values(filteredContentDataModel)"
    item-title="title"
    color="primary"
    hide-actions
  >
    <template
      v-for="(group, group_key, index) in filteredContentDataModel"
      #[`item.${index+1}`]
    >
      <VCard flat>
        <VCardText>
          <template v-if="index == 0">
            <!-- template for first tab -->
            <VSwitch
              v-model="showScheduleGroup"
              label="Schedule pipeline execution"
              class="mb-3"
            />
            <VRow
              v-if="showScheduleGroup"
              class="mb-3 align-items-center"
            >
              <VCol
                cols="12"
                class="mb-2"
              >
                <h4 class="mb-0">
                  Schedule Group Configuration
                </h4>
                <small class="text-muted">
                  In this section, you can schedule the pipeline.
                </small>
              </VCol>
              <VCol
                cols="12"
                md="4"
              >
                <VTextField
                  v-model="schedule.description"
                  label="Description"
                  placeholder="Provide a short description for this pipeline"
                />
              </VCol>

              <VCol
                cols="12"
                md="4"
              >
                <VTextField
                  v-model="schedule.intervalPattern"
                  label="Interval Pattern"
                  placeholder="29 1 * * *"
                />
              </VCol>

              <VCol
                cols="12"
                md="auto"
                class="align-self-center"
              >
                <VCheckbox
                  v-model="schedule.isActive"
                  label="Activated"
                />
              </VCol>

              <VCol cols="12">
                <VDivider />
              </VCol>
            </VRow>
            <VSwitch
              v-model="SelectGroups"
              class="mb-4"
              label="Select Groups Configuration"
              color="primary"
            />
            <VRow v-if="SelectGroups">
              <VCol
                v-for="(item) in tabsToShow.slice(1)"
                class="ml-6 mb-1 pa-0"
                cols="12"
              >
                <VSwitch
                  v-model="item.enabled"
                  :label="item.name"
                  color="info"
                  hide-details
                />
              </VCol>
              <VDivider />
            </VRow>
          </template>
          <!-- PIPELINE VARIABLES FORM -->
          <!-- v-checkbox v-model="showVariablesGroup" label="Pipeline Variables Form" class="mb-3" /! -->
          <VRow v-if="showVariablesGroup">
            <VCol
              cols="12"
              class="mb-2"
            >
              <h4 class="mb-0">
                {{ group.cardTitle }}
              </h4>
              <small class="text-muted">{{ group.cardSubtitle }}</small>
            </VCol>

            <VCol cols="12">
              <VAlert
                v-if="errorMessage"
                icon="tabler-info-circle"
                type="error"
                title="ERROR!"
                closable
              >
                <span v-html="errorMessage" />
              </VAlert>
            </VCol>
            <VCol cols="12">
              <VAlert
                v-if="isRequest"
                icon="tabler-info-circle"
                :type="alertToggleVariant"
                :title="alertToggleText"
                :text="requestMessage"
                closable
              />
            </VCol>

            <VCol
              v-for="(content, content_key) in group.content"
              :key="content_key"
              md="6"
              cols="12"
            >
              <!-- Form Field Types    v-if="!envVars[group_key][content_key].hidden" -->
              <template v-if="!validInputValues.includes(content.type.toLowerCase())">
                <VAlert type="error">
                  <VIcon class="mr-2">
                    tabler-info-circle
                  </VIcon>
                  <strong>ERROR!</strong> Wrong format for {{ content.id }} variable.
                  {{ content.type }} is not valid, it must be one of {{ validInputValues }}.
                </VAlert>
              </template>

              <!-- Selector -->
              <template v-else-if="content.type.toLowerCase() === 'selector'">
                <VSelect
                  v-if="hasLabelField(content.options)"
                  v-model="envVars[group_key][content_key].value"
                  base-color="primary"
                  :items="content.options"
                  item-title="label"
                  item-value="value"
                  label="Select"
                  :required="content.required"
                  @change="handleFormsChange"
                />
                <VAlert
                  v-else
                  type="error"
                >
                  Error: One or more options in the selection for {{ content_key }} are missing the 'label' field.
                </VAlert>
              </template>

              <!-- File Input -->
              <template v-else-if="content.type.toLowerCase() === 'file'">
                <VFileInput
                  v-model="envVars[group_key][content_key].value"
                  base-color="primary"
                  label="File"
                  placeholder="Choose a file or drop it here..."
                  :required="content.required"
                />
              </template>

              <!-- Checkbox -->
              <template v-else-if="content.type.toLowerCase() === 'checkbox'">
                <VSwitch
                  v-model="envVars[group_key][content_key].value"
                  color="primary"
                  :label="content.text"
                  :required="content.required"
                  @change="handleFormsChange"
                />
              </template>

              <!-- Textarea -->
              <template v-else-if="content.type.toLowerCase() === 'textarea'">
                <VTextarea
                  v-model="envVars[group_key][content_key].value"
                  base-color="primary"
                  :label="content.label"
                  :required="content.required"
                />
              </template>

              <!-- Simple Input -->
              <template v-else>
                <VTextField
                  v-model="envVars[group_key][content_key].value"
                  base-color="primary"
                  :label="content.label"
                  :type="content.type"
                  :required="content.required"
                  @input="handleFormsChange"
                />
              </template>
            </VCol>

            <VCol cols="12">
              <VDivider />
            </VCol>
          </VRow>
          <!-- END PIPELINE VARIABLES FORM -->
        </VCardText>
      </VCard>
    </template>
    <template #default="{ prev, next }">
      <VStepperActions
        v-if="step < Object.values(filteredContentDataModel).length"
        @click:next="next"
        @click:prev="prev"
      />
      <VStepperActions
        v-else-if="showScheduleGroup && step == 1"
        next-text="Schedule pipeline"
        disabled="prev"
        @click:next="onCompleteWizard"
        @click:prev="prev"
      />
      <VStepperActions
        v-else-if="showScheduleGroup && step > 1"
        next-text="Schedule pipeline"
        disabled="false"
        @click:next="onCompleteWizard"
        @click:prev="prev"
      />
      <VStepperActions
        v-else-if="!showScheduleGroup && step == 1"
        next-text="Run pipeline"
        disabled="prev"
        @click:next="onCompleteWizard"
        @click:prev="prev"
      />
      <VStepperActions
        v-else-if="!showScheduleGroup && step > 1"
        next-text="Run pipeline"
        disabled="false"
        @click:next="onCompleteWizard"
        @click:prev="prev"
      />
    </template>
  </VStepper>
</template>
